searchNodes=[{"doc":"An aggregate is the unit of business logic in the domain. The business logic is used to handle commands and also to apply events to change the aggregate state.This behaviour defines the callbacks for command execution and event application.","ref":"Incident.Aggregate.html","title":"Incident.Aggregate","type":"behaviour"},{"doc":"Receives a persisted event and the aggregate state, performing an aggregate state update.","ref":"Incident.Aggregate.html#c:apply/2","title":"Incident.Aggregate.apply/2","type":"callback"},{"doc":"Receives and executes the command, performing a specific business logic for it, usually considering the aggregate state as part of the logic.In case of a successful command and logic, a new event is composed and returned along with the aggregate state.In case of an unsuccessful command and logic, an error is returned containing a business logic reason.","ref":"Incident.Aggregate.html#c:execute/1","title":"Incident.Aggregate.execute/1","type":"callback"},{"doc":"Defines an Aggregate State macro that receives the aggregate module and an initial state.","ref":"Incident.AggregateState.html","title":"Incident.AggregateState","type":"module"},{"doc":"Defines the API for a Command.","ref":"Incident.Command.html","title":"Incident.Command","type":"behaviour"},{"doc":"Returns if a command is valid or not.","ref":"Incident.Command.html#c:valid?/1","title":"Incident.Command.valid?/1","type":"callback"},{"doc":"Defines a Command Handler that receives a command to:ensure that the command data is valid based on the command validations;executes the command using the aggregate;","ref":"Incident.CommandHandler.html","title":"Incident.CommandHandler","type":"module"},{"doc":"Defines the API for an Event Handler.","ref":"Incident.EventHandler.html","title":"Incident.EventHandler","type":"behaviour"},{"doc":"Listens to a persisted event and an aggregate state. You can use the aggregate to apply the persisted event and its state to get a new state, and to project new data into the projection store.","ref":"Incident.EventHandler.html#c:listen/2","title":"Incident.EventHandler.listen/2","type":"callback"},{"doc":"Defines the API to interact with the Event Store.The data source is based on the configured Event Store Adapter.","ref":"Incident.EventStore.html","title":"Incident.EventStore","type":"module"},{"doc":"Defines the API for an Event Store adapter.","ref":"Incident.EventStore.Adapter.html","title":"Incident.EventStore.Adapter","type":"behaviour"},{"doc":"Appends an event to the Event Store.","ref":"Incident.EventStore.Adapter.html#c:append/1","title":"Incident.EventStore.Adapter.append/1","type":"callback"},{"doc":"Receives an aggregate id and returns a list containing all persisted events from the Event Store.","ref":"Incident.EventStore.Adapter.html#c:get/1","title":"Incident.EventStore.Adapter.get/1","type":"callback"},{"doc":"Depending the adapter used to store the events, the persisted event will be defined by a different schema.","ref":"Incident.EventStore.Adapter.html#t:persisted_event/0","title":"Incident.EventStore.Adapter.persisted_event/0","type":"type"},{"doc":"Implements an in-memory Event Store using Agents.","ref":"Incident.EventStore.InMemoryAdapter.html","title":"Incident.EventStore.InMemoryAdapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.InMemoryAdapter.html#child_spec/1","title":"Incident.EventStore.InMemoryAdapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.EventStore.InMemoryAdapter.html#start_link/1","title":"Incident.EventStore.InMemoryAdapter.start_link/1","type":"function"},{"doc":"Defines the data structure for any event for the in memory adapter.All fields are required.","ref":"Incident.EventStore.InMemoryEvent.html","title":"Incident.EventStore.InMemoryEvent","type":"module"},{"doc":"","ref":"Incident.EventStore.InMemoryEvent.html#t:t/0","title":"Incident.EventStore.InMemoryEvent.t/0","type":"type"},{"doc":"Implements an Event Store using Postgres through Ecto.","ref":"Incident.EventStore.PostgresAdapter.html","title":"Incident.EventStore.PostgresAdapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.EventStore.PostgresAdapter.html#child_spec/1","title":"Incident.EventStore.PostgresAdapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.EventStore.PostgresAdapter.html#start_link/1","title":"Incident.EventStore.PostgresAdapter.start_link/1","type":"function"},{"doc":"Defines the data structure for any event for the Postgres adapter.All fields are required.","ref":"Incident.EventStore.PostgresEvent.html","title":"Incident.EventStore.PostgresEvent","type":"module"},{"doc":"","ref":"Incident.EventStore.PostgresEvent.html#t:t/0","title":"Incident.EventStore.PostgresEvent.t/0","type":"type"},{"doc":"Defines the API to interact with the Projection Store.The data source is based on the configured Projection Store Adapter.","ref":"Incident.ProjectionStore.html","title":"Incident.ProjectionStore","type":"module"},{"doc":"Defines the API for a Projection Store adapter.","ref":"Incident.ProjectionStore.Adapter.html","title":"Incident.ProjectionStore.Adapter","type":"behaviour"},{"doc":"Returns all projections from a specific projection type from the Projection Store.","ref":"Incident.ProjectionStore.Adapter.html#c:all/1","title":"Incident.ProjectionStore.Adapter.all/1","type":"callback"},{"doc":"Insert or updates a projection in the Projection Store.Receives the projection type and the data for the projection.","ref":"Incident.ProjectionStore.Adapter.html#c:project/2","title":"Incident.ProjectionStore.Adapter.project/2","type":"callback"},{"doc":"Implements an in-memory Projection Store using Agents.","ref":"Incident.ProjectionStore.InMemoryAdapter.html","title":"Incident.ProjectionStore.InMemoryAdapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.ProjectionStore.InMemoryAdapter.html#child_spec/1","title":"Incident.ProjectionStore.InMemoryAdapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.ProjectionStore.InMemoryAdapter.html#start_link/1","title":"Incident.ProjectionStore.InMemoryAdapter.start_link/1","type":"function"},{"doc":"Implements a Projection Store using Postgres through Ecto.","ref":"Incident.ProjectionStore.PostgresAdapter.html","title":"Incident.ProjectionStore.PostgresAdapter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Incident.ProjectionStore.PostgresAdapter.html#child_spec/1","title":"Incident.ProjectionStore.PostgresAdapter.child_spec/1","type":"function"},{"doc":"","ref":"Incident.ProjectionStore.PostgresAdapter.html#start_link/1","title":"Incident.ProjectionStore.PostgresAdapter.start_link/1","type":"function"},{"doc":"This task will generate some basic setup when using PostgresAdapter.When using this adapter you will need to have a table to store the events. This task will generate an Ecto migration to create the events table with the needed columns and indexes. The task will respect your Ecto configuration for your EventStoreRepo.Usagemix incident.postgres.init -r AppName.EventStoreRepo","ref":"Mix.Tasks.Incident.Postgres.Init.html","title":"Mix.Tasks.Incident.Postgres.Init","type":"task"},{"doc":"IncidentEvent Sourcing and CQRS in Elixir abstractions.Special thanks to my friend Paulo Gonzalez for the name suggestion for this library.","ref":"readme.html","title":"Incident","type":"extras"},{"doc":"incentivize the usage of Event Sourcing and CQRS as good choice for domains that can leverage the main benefits of this design pattern;serve as guidance when using Event Sourcing in your system with proper contracts;leverage functions and reducers for executing commands and applying events;allow customization for fine-grained needs without compromising the principles;","ref":"readme.html#goals","title":"Incident - Goals","type":"extras"},{"doc":"In a nutshell, Event Sourcing ensures that all changes to application state are stored as a sequence of events. But if you are new to Event Sourcing and CQRS I highly recommend watch Greg Young's presentation at Code on the Beach 2014 before moving forward.","ref":"readme.html#event-sourcing-and-cqrs","title":"Incident - Event Sourcing and CQRS","type":"extras"},{"doc":"Command is a data structure with basic validation;Command Handler is the entry point of a command in the write side, it performs basic command validation and executes the command through the aggregate;Aggregate only defines its business logic to execute a command and apply an event, but not its state;Aggregate State is defined by playing all the events through Aggregate business logic;Event is a data structure;Event Handler receives a persisted event and performs the actions in the read side;Event Store and Projection Store are swappable persistence layers to allow different technologies over time;Projection can be rebuilt based on the persisted events and on the same Aggregate business logic;","ref":"readme.html#main-components","title":"Incident - Main Components","type":"extras"},{"doc":"The list below is the upcoming enhacements or fixes, it will grow as the library is being developed.[ ] run migrations when using mix incident.postgres.init for Postgres adapter;[ ] add Process Managers to orchestrate more complex business logic or side effects, with rollback actions;[ ] add error modules and incorporate as part of the contract in some components;","ref":"readme.html#planned-next-steps","title":"Incident - Planned Next Steps","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding incident to your list of dependencies in mix.exs:def deps do [ {:incident, &quot;~&gt; 0.4.0&quot;} ] end","ref":"readme.html#installation","title":"Incident - Installation","type":"extras"},{"doc":"Event Store and Projection Store SetupConfigure incident Event Store and Projection Store adapters and some options. The options will be passed in during the adapter initialization.In Memory AdapterThe goal of using the In Memory Adapter is to provide a quick way to store events and projections, as a playground tool. This adapter is not suppose to be used in a real application.config :incident, :event_store, adapter: Incident.EventStore.InMemoryAdapter, options: [ initial_state: [] ] config :incident, :projection_store, adapter: Incident.ProjectionStore.InMemoryAdapter, options: [ initial_state: %{} ]Postgres AdapterThe Postgres adapter uses Ecto behind the scenes so a lot of its configuration it is simply how you should configure a Postgres database for any application using Ecto.There will be two databases, one to store the events and another one to be used by the projections. The events database will contain only one table (events) and the projections database will contain one table fore each projection type.Add the Ecto Repo modules for both databases:defmodule AppName.EventStoreRepo do use Ecto.Repo, otp_app: :app_name, adapter: Ecto.Adapters.Postgres end defmodule AppName.ProjectionStoreRepo do use Ecto.Repo, otp_app: :app_name, adapter: Ecto.Adapters.Postgres end In your application config.exs specify the repositories:config :app_name, ecto_repos: [AppName.EventStoreRepo, AppName.ProjectionStoreRepo]In your application dev|test|prod.exs:config :app_name, AppName.EventStoreRepo, username: &quot;postgres&quot;, password: &quot;postgres&quot;, hostname: &quot;localhost&quot;, database: &quot;app_name_event_store_dev&quot; config :app_name, AppName.ProjectionStoreRepo, username: &quot;postgres&quot;, password: &quot;postgres&quot;, hostname: &quot;localhost&quot;, database: &quot;app_name_projection_store_dev&quot; config :incident, :event_store, adapter: Incident.EventStore.PostgresAdapter, options: [ repo: AppName.EventStoreRepo ] config :incident, :projection_store, adapter: Incident.ProjectionStore.PostgresAdapter, options: [ repo: AppName.ProjectionStoreRepo ]Create the application databases running the Ecto mix task:mix ecto.createUse the Incident Mix task to generate the events table migration, and run the migration:mix incident.postgres.init -r AppName.EventStoreRepo mix ecto.migrateThe migrations and schemas for the projections will depend on your application domains.","ref":"readme.html#configuration","title":"Incident - Configuration","type":"extras"},{"doc":"There is an example application that implements a Bank application for reference, including all the details and usage in IEx as well.It also contains projections specific to the application domain with migration and schemas defined.This example application will give you all the details in how to use Incident, including integration tests.","ref":"readme.html#getting-started","title":"Incident - Getting Started","type":"extras"},{"doc":"The full documentation can be found at https://hexdocs.pm/incident.","ref":"readme.html#documentation","title":"Incident - Documentation","type":"extras"}]